**    ModelEco : MODELisation en programmation mathmatique pour l'analyse ECOnomique de l'agriculure    **

*-----------------------------------------------------------------------------*
$Ontext
Nom              Primal1
Sequence         1 - Introduction  la programmation mathmatique avec GAMS
Cours            2 - Introduction a GAMS
Auteurs          ??
Type             LP
Langage GAMS     Paramtre calcul, display, .up, .lo
Description
Ajout du calcul de la marge brute
" Soit une exploitation agricole qui peut pratiquer deux cultures : le bl et le mas.
On cherche  dterminer la superficie  cultiver dans chaque production, sachant que :
L'objectif de l'agriculteur est la maximisation du revenu
Par hectare, le rendement du bl est de 5 tonnes et celui du mais de 10 tonnes.
Respectivement, ils ont des couts de production de 300/ha et 500/ha. Les deux crales sont vendues 150/tonnes.
Le bl utilise 25 heures de travail par ha et par an et le mais 50 heures
La surface de l'exploitation est de 50 ha et l'agriculteur dispose de 2000 heures de travail par an. "


$Offtext
*-----------------------------------------------------------------------------*


*----------                          INDICES                        ----------*
sets
C cultures  /ble,mais/
;

*----------                          DONNEES                        ----------*
scalar
DTERRE disponibilite de terre en hectares       /50/
DMO    disponibilite de travail en heures     /2000/
;

parameter
BMO(C) besoins en travail par hectare et par culture (heures)
/ble    25
 mais   50/

RDT (C) rendement par culture en tonne par hectar
/ ble 5
 mais 10/

PX (C) prix de vente par culture en euros
/ ble 150
 mais 150/

COUT (C) cout variable par culture en euros par ha
/ ble 300
 mais 500/
;

parameter
MB(C) marge brute par culture en euros    ;
MB(C) = RDT(C)*PX(C)-COUT(C);

*display MB ;

*$exit

*----------                         MODELE                          ----------*
variables
   Z    revenu total de l exploitation (euros)
;

positive variables
   X superficie par culture (hectares)
;
X.l('ble')=1;
display X.l ;

equations
   OBJECTIF       fonction objectif
   TERRE          contrainte de terre
   TRAVAIL        contrainte de travail
;

OBJECTIF..  sum (C, MB(C)* X(C)) =E= Z ;

TERRE..    sum(c, X(c)) =l= dterre ;

TRAVAIL..  sum(c, bmo(c)*X(c)) =L= dmo;


model exemple premier exemple /all/;

*----------                        SOLUTION                         ----------*
solve exemple using LP maximizing Z;

*----------                         DISPLAY                         ----------*
display MB, C, DTERRE ;
display X.l;
display TERRE.l ;
display X.m ;




